=== debian/changelog ===
ros-lunar-abseil-cpp (0.2.3-0stretch) stretch; urgency=high

  * Fix issue #1 <https://github.com/Eurecat/abseil-cpp/issues/1>
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 23:00:00 -0000

ros-lunar-abseil-cpp (0.2.2-0stretch) stretch; urgency=high

  * removing rsync
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 14 Nov 2017 23:00:00 -0000

ros-lunar-abseil-cpp (0.2.0-0stretch) stretch; urgency=high

  * reorganized the files
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Fri, 13 Oct 2017 22:00:00 -0000

ros-lunar-abseil-cpp (0.1.3-0stretch) stretch; urgency=high

  * rebase
  * Update CMakeLists.txt
  * Contributors: Abseil Team, Bronek Kozicki, Davide Faconti, Gennadiy Civil, Gennadiy Rozental, Matt Calabrese, misterg, vslashg

 -- dfaconti <davide.faconti@gmail.com>  Thu, 12 Oct 2017 22:00:00 -0000

ros-lunar-abseil-cpp (0.1.2-0stretch) stretch; urgency=high

  * Update CMakeLists.txt
  * Contributors: Davide Faconti

 -- dfaconti <davide.faconti@gmail.com>  Tue, 03 Oct 2017 22:00:00 -0000

ros-lunar-abseil-cpp (0.1.1-0stretch) stretch; urgency=high

  * Merge branch 'master' of https://github.com/Eurecat/abseil-cpp
  * test removed
  * Update README.md
  * Initial Commit
  * Contributors: Abseil Team, Ben Cox, Davide Faconti, Derek Mauro, misterg

 -- dfaconti <davide.faconti@gmail.com>  Sat, 30 Sep 2017 22:00:00 -0000
